=== debian/changelog ===
cyclonedds (0.7.0-7) unstable; urgency=medium

  * Enforce 16 byte alignment on s390x for __sync_bool_compare_and_swap_16

 -- Timo Röhling <timo@gaussglocke.de>  Fri, 05 Feb 2021 22:22:13 +0100

cyclonedds (0.7.0-6) unstable; urgency=medium

  * Use build-essential dependency for autopkgtest

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 04 Feb 2021 19:46:11 +0100

cyclonedds (0.7.0-5) unstable; urgency=medium

  * Fix syntax error in d/rules

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 04 Feb 2021 17:16:27 +0100

cyclonedds (0.7.0-4) unstable; urgency=medium

  * Hardcode libatomic dependency for now

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 04 Feb 2021 15:10:36 +0100

cyclonedds (0.7.0-3) unstable; urgency=medium

  * Update symbols
  * Fix independent builds for all and any
  * Link against libatomic

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 04 Feb 2021 13:14:57 +0100

cyclonedds (0.7.0-2) unstable; urgency=medium

  * Source only upload.

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 04 Feb 2021 10:32:05 +0100

cyclonedds (0.7.0-1) unstable; urgency=medium

  * Initial release (Closes: #980177)

 -- Timo Röhling <timo@gaussglocke.de>  Fri, 15 Jan 2021 19:03:10 +0100
