=== debian/control ===
Source: cyclonedds
Section: libs
Priority: optional
Maintainer: Timo Röhling <timo@gaussglocke.de>
Build-Depends: debhelper-compat (= 13),
               cmake, libssl-dev,
               default-jdk, javahelper, maven-debian-helper, maven-repo-helper,
               antlr4-maven-plugin,
               libbuild-helper-maven-plugin-java,
               libmaven-resources-plugin-java,
               libmaven-jar-plugin-java,
               libmaven-antrun-plugin-java,
               libmaven-compiler-plugin-java,
               antlr3,
               antlr4,
               libstringtemplate-java,
               libstringtemplate4-java,
               ant-optional,
               libantlr-java,
               libcunit1-dev <!nocheck>,
               doxygen <!nodoc>, graphviz <!nodoc>, python3-sphinx <!nodoc>,
               python3-breathe <!nodoc>
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://projects.eclipse.org/projects/iot.cyclonedds
Vcs-Git: https://salsa.debian.org/roehling/cyclonedds.git
Vcs-Browser: https://salsa.debian.org/roehling/cyclonedds

Package: libddsc0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Eclipse Cyclone DDS library
 Eclipse Cyclone DDS is a very performant and robust open-source DDS
 implementation. Cyclone DDS is developed completely in the open as an
 Eclipse IoT project with a growing list of adopters. It is a tier-1
 middleware for the Robot Operating System (ROS 2).

Package: libddsc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Recommends: libddsc-tools
Depends: libddsc0 (= ${binary:Version}), ${misc:Depends}
Description: Eclipse Cyclone DDS library - development headers
 Eclipse Cyclone DDS is a very performant and robust open-source DDS
 implementation. Cyclone DDS is developed completely in the open as an
 Eclipse IoT project with a growing list of adopters. It is a tier-1
 middleware for the Robot Operating System (ROS 2).
 .
 This package installs the development headers.

Package: libddsc-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Description: Eclipse Cyclone DDS library - API documentation
 Eclipse Cyclone DDS is a very performant and robust open-source DDS
 implementation. Cyclone DDS is developed completely in the open as an
 Eclipse IoT project with a growing list of adopters. It is a tier-1
 middleware for the Robot Operating System (ROS 2).
 .
 This package installs the API documentation.

Package: libddsc-tools
Section: net
Architecture: any
Depends: ${java:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Eclipse Cyclone DDS tools
 Eclipse Cyclone DDS is a very performant and robust open-source DDS
 implementation. Cyclone DDS is developed completely in the open as an
 Eclipse IoT project with a growing list of adopters. It is a tier-1
 middleware for the Robot Operating System (ROS 2).
 .
 This package installs the command-line tools for Cyclone DDS.
