=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/,\
     uversionmangle=s/[-.]?(a|b|pre)/~$1/ \
  https://github.com/eclipse-cyclonedds/cyclonedds/releases/latest .*/v?(\d\S+)\.tar\.gz
